clear
N=input('Enter N ');
M=input('Enter the number of eigenvalues ');
A=speye((N-1)^2,(N-1)^2)*4;
for i=1:(N-1)^2-1
if i~=N-1:N-1:(N-1)^2-(N-1)
  A(i,i+1)=-1;
  A(i+1,i)=-1;
end
end
for i=1:(N-1)^2-(N-1)
  A(i,i+N-1)=-1;
  A(i+N-1,i)=-1;
end
A=A*N^2;

[V,lambda]=eigs(A,M,'sa');
lambda=eigs(A,M,'sa');

for i=1:M
for j=1:M
R(i,j)=(i^2+j^2)*pi^2;
end
end

R=R(:);
R=sort(R);

for i=1:M
fprintf('th-lambda %d = %f\tm-lambda %d = %f\ter = %f\n',i,R(i),i,lambda(i),R(i)-lambda(i));
end

fprintf('\n');

fprintf('Enter a lambda-number from 1 to %d, so I will draw the "phi(x,y)".\n',M);
a=input('');
fprintf('Enter another lambda-number. If you don''t need another lambda, enter"0".\n');
b=input('');
if b==0
fprintf('phi(x,y) = p*phi_%d\n',a);
p=input('Enter p ');
end
if b~=0
fprintf('phi(x,y) = p*phi_%d + q*phi_%d\n',a,b);
p=input('Enter p ');
q=input('Enter q ');
end

for i=1:(N-1)^2
Y(1,i)=V(i,a);
end
B=zeros(N-1,N-1);
B=reshape(Y,N-1,N-1);
B=B';
if b==0
B=p*B;
end
if b~=0
for i=1:(N-1)^2
Z(1,i)=V(i,b);
end
C=zeros(N-1,N-1);
C=reshape(Z,N-1,N-1);
C=C';
B=p*B+q*C;
end

B=[zeros(1,N+1);zeros(N-1,1) B zeros(N-1,1);zeros(1,N+1)];
x=linspace(0,1,N+1);
grid('on');
subplot(1,2,1);
mesh(x,x,B)
subplot(1,2,2);
contour(x,x,B',5)

